Subject: bug#65460: ghc/ghci are broken

From: Saku Laesvuori <[email-masked]>
Date: Wed, 23 Aug 2023 19:16:14 +0300

> > Thanks! Adding gcc-toolchain to the profile fixed it, but shouldn't this 
> > be automatically brought in by `guix install ghc`? This does still feels 
> > like a bug to me, shouldn't gcc-toolchain be a part of ghcs native-inputs?

native-inputs are for buildtime inputs and here ghc needs a c toolchain
at runtime to compile another haskell program so gcc-toolchain should be
in "normal" inputs.

> I assume GHC can work with other toolchains, like Clang, so it's better
> to be explicit about what you want to use.

I think it would still be good to have a c toolchain as an input. Guix
packages are, if I understand correctly, supposed to work without having
to explicitly install their dependencies. If someone wants to use a
different c toolchain than the default, they can use a package
transformation to change it.

Maybe we could even have the current ghc as a hidden package and have
the public package wrap the hidden ghc adding gcc-toolchain to it's
environment, so that changing the c toolchain wouldn't require
rebuilding ghc.